using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Threading;
using System.Windows.Forms;
using System.Data;

namespace CPFLite
{

	//These create the reader thread delegates.
	//All threading code shamelessly stolen from The Code Project, at:
	// http://www.codeproject.com/csharp/workerthread.asp
	public delegate void DelegateAddString(String[] s);
	public delegate void DelegateThreadFinished();

	public class CPFLite : System.Windows.Forms.Form
	{

		#region Delagate Thread handlers

		//Threading delegate stuff:
		//These variables deal with the background thread used to read
		//the serial port.
		Thread m_WorkerThread;
		ManualResetEvent m_EventStopThread;
		ManualResetEvent m_EventThreadStopped;
		public DelegateAddString m_DelegateAddString;
		public DelegateThreadFinished m_DelegateThreadFinished;

		#endregion

		//These will be used to create the excel dumper and determine
		//if excel is running.
		ExcelDump exDump;
		bool bExcelRunning = false;

		public bool bP1Enabled = false;
		public bool bP2Enabled = false;

		//This will be used to determine the state of the Start/Stop button
		private bool bBtnOn = false;
		
		#region Windows Form variables.. Default.

		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.TextBox tbTime;
		private System.Windows.Forms.TextBox tbV1;
		private System.Windows.Forms.TextBox tbV2;
		private System.Windows.Forms.TextBox tbV3;
		private System.Windows.Forms.TextBox tbV4;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.ComboBox cbComPort;
		private System.Windows.Forms.TextBox tbA1;
		private System.Windows.Forms.TextBox tbA2;
		private System.Windows.Forms.TextBox tbA3;
		private System.Windows.Forms.TextBox tbA4;
		private System.Windows.Forms.CheckBox ckA1;
		private System.Windows.Forms.CheckBox ckA2;
		private System.Windows.Forms.CheckBox ckA3;
		private System.Windows.Forms.CheckBox ckA4;
		private System.Windows.Forms.TextBox tbVref;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Button btStartExcel;
		private System.Windows.Forms.PictureBox pbLines1;
		private System.Windows.Forms.PictureBox pbLines2;
		private System.Windows.Forms.TextBox tPower1;
		private System.Windows.Forms.TextBox tEfficiency;
		private System.Windows.Forms.TextBox tPower2;
		private System.Windows.Forms.Label lbP1;
		private System.Windows.Forms.Label lbP2;
		private System.Windows.Forms.Label lbEff;

		private System.ComponentModel.Container components = null;

		#endregion

		public CPFLite()
		{
			InitializeComponent();

			// initialize delegates
			m_DelegateAddString = new DelegateAddString(this.AddString);
			m_DelegateThreadFinished = new DelegateThreadFinished(this.ThreadFinished);
			m_EventStopThread = new ManualResetEvent(false);
			m_EventThreadStopped = new ManualResetEvent(false);
		}


		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Windows Form Designer generated code

		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(CPFLite));
			this.button1 = new System.Windows.Forms.Button();
			this.tbTime = new System.Windows.Forms.TextBox();
			this.tbV1 = new System.Windows.Forms.TextBox();
			this.tbV2 = new System.Windows.Forms.TextBox();
			this.tbV3 = new System.Windows.Forms.TextBox();
			this.tbV4 = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.cbComPort = new System.Windows.Forms.ComboBox();
			this.tbA1 = new System.Windows.Forms.TextBox();
			this.tbA2 = new System.Windows.Forms.TextBox();
			this.tbA3 = new System.Windows.Forms.TextBox();
			this.tbA4 = new System.Windows.Forms.TextBox();
			this.ckA1 = new System.Windows.Forms.CheckBox();
			this.ckA2 = new System.Windows.Forms.CheckBox();
			this.ckA3 = new System.Windows.Forms.CheckBox();
			this.ckA4 = new System.Windows.Forms.CheckBox();
			this.tbVref = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.label13 = new System.Windows.Forms.Label();
			this.label14 = new System.Windows.Forms.Label();
			this.label15 = new System.Windows.Forms.Label();
			this.btStartExcel = new System.Windows.Forms.Button();
			this.pbLines1 = new System.Windows.Forms.PictureBox();
			this.pbLines2 = new System.Windows.Forms.PictureBox();
			this.tPower1 = new System.Windows.Forms.TextBox();
			this.tEfficiency = new System.Windows.Forms.TextBox();
			this.tPower2 = new System.Windows.Forms.TextBox();
			this.lbP1 = new System.Windows.Forms.Label();
			this.lbP2 = new System.Windows.Forms.Label();
			this.lbEff = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(144, 304);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(72, 23);
			this.button1.TabIndex = 0;
			this.button1.Text = "Start Log";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// tbTime
			// 
			this.tbTime.Location = new System.Drawing.Point(8, 24);
			this.tbTime.Name = "tbTime";
			this.tbTime.ReadOnly = true;
			this.tbTime.Size = new System.Drawing.Size(88, 20);
			this.tbTime.TabIndex = 1;
			this.tbTime.TabStop = false;
			this.tbTime.Text = "Time";
			// 
			// tbV1
			// 
			this.tbV1.Location = new System.Drawing.Point(40, 56);
			this.tbV1.Name = "tbV1";
			this.tbV1.ReadOnly = true;
			this.tbV1.Size = new System.Drawing.Size(56, 20);
			this.tbV1.TabIndex = 2;
			this.tbV1.TabStop = false;
			this.tbV1.Text = "Volts-In 1";
			this.tbV1.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// tbV2
			// 
			this.tbV2.Location = new System.Drawing.Point(40, 112);
			this.tbV2.Name = "tbV2";
			this.tbV2.ReadOnly = true;
			this.tbV2.Size = new System.Drawing.Size(56, 20);
			this.tbV2.TabIndex = 3;
			this.tbV2.TabStop = false;
			this.tbV2.Text = "Volts-In 2";
			this.tbV2.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// tbV3
			// 
			this.tbV3.Location = new System.Drawing.Point(40, 168);
			this.tbV3.Name = "tbV3";
			this.tbV3.ReadOnly = true;
			this.tbV3.Size = new System.Drawing.Size(56, 20);
			this.tbV3.TabIndex = 4;
			this.tbV3.TabStop = false;
			this.tbV3.Text = "Volts-In 3";
			this.tbV3.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// tbV4
			// 
			this.tbV4.Location = new System.Drawing.Point(40, 224);
			this.tbV4.Name = "tbV4";
			this.tbV4.ReadOnly = true;
			this.tbV4.Size = new System.Drawing.Size(56, 20);
			this.tbV4.TabIndex = 5;
			this.tbV4.TabStop = false;
			this.tbV4.Text = "Volts-In 4";
			this.tbV4.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(48, 16);
			this.label1.TabIndex = 6;
			this.label1.Text = "Time:";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(8, 224);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(32, 16);
			this.label2.TabIndex = 7;
			this.label2.Text = "In4:";
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(8, 168);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(32, 16);
			this.label3.TabIndex = 8;
			this.label3.Text = "In3:";
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(8, 112);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(32, 16);
			this.label4.TabIndex = 9;
			this.label4.Text = "In2:";
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.Location = new System.Drawing.Point(8, 56);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(32, 16);
			this.label5.TabIndex = 10;
			this.label5.Text = "In1:";
			// 
			// cbComPort
			// 
			this.cbComPort.Items.AddRange(new object[] {
														   "COM1",
														   "COM2",
														   "COM3",
														   "COM4",
														   "COM5"});
			this.cbComPort.Location = new System.Drawing.Point(8, 304);
			this.cbComPort.Name = "cbComPort";
			this.cbComPort.Size = new System.Drawing.Size(56, 21);
			this.cbComPort.TabIndex = 11;
			this.cbComPort.Text = "COM1";
			this.cbComPort.SelectedIndexChanged += new System.EventHandler(this.cbComPort_SelectedIndexChanged);
			// 
			// tbA1
			// 
			this.tbA1.Location = new System.Drawing.Point(56, 80);
			this.tbA1.Name = "tbA1";
			this.tbA1.Size = new System.Drawing.Size(40, 20);
			this.tbA1.TabIndex = 12;
			this.tbA1.Text = "0";
			// 
			// tbA2
			// 
			this.tbA2.Location = new System.Drawing.Point(56, 136);
			this.tbA2.Name = "tbA2";
			this.tbA2.Size = new System.Drawing.Size(40, 20);
			this.tbA2.TabIndex = 13;
			this.tbA2.Text = "0";
			// 
			// tbA3
			// 
			this.tbA3.Location = new System.Drawing.Point(56, 192);
			this.tbA3.Name = "tbA3";
			this.tbA3.Size = new System.Drawing.Size(40, 20);
			this.tbA3.TabIndex = 14;
			this.tbA3.Text = "0";
			// 
			// tbA4
			// 
			this.tbA4.Location = new System.Drawing.Point(56, 248);
			this.tbA4.Name = "tbA4";
			this.tbA4.Size = new System.Drawing.Size(40, 20);
			this.tbA4.TabIndex = 15;
			this.tbA4.Text = "0";
			// 
			// ckA1
			// 
			this.ckA1.Location = new System.Drawing.Point(40, 80);
			this.ckA1.Name = "ckA1";
			this.ckA1.Size = new System.Drawing.Size(16, 16);
			this.ckA1.TabIndex = 16;
			this.ckA1.Text = "checkBox1";
			this.ckA1.CheckedChanged += new System.EventHandler(this.ckA1_CheckedChanged);
			// 
			// ckA2
			// 
			this.ckA2.Location = new System.Drawing.Point(40, 136);
			this.ckA2.Name = "ckA2";
			this.ckA2.Size = new System.Drawing.Size(16, 16);
			this.ckA2.TabIndex = 17;
			this.ckA2.Text = "checkBox2";
			this.ckA2.CheckedChanged += new System.EventHandler(this.ckA2_CheckedChanged);
			// 
			// ckA3
			// 
			this.ckA3.Location = new System.Drawing.Point(40, 192);
			this.ckA3.Name = "ckA3";
			this.ckA3.Size = new System.Drawing.Size(16, 16);
			this.ckA3.TabIndex = 18;
			this.ckA3.Text = "checkBox3";
			this.ckA3.CheckedChanged += new System.EventHandler(this.ckA3_CheckedChanged);
			// 
			// ckA4
			// 
			this.ckA4.Location = new System.Drawing.Point(40, 248);
			this.ckA4.Name = "ckA4";
			this.ckA4.Size = new System.Drawing.Size(16, 16);
			this.ckA4.TabIndex = 19;
			this.ckA4.Text = "checkBox4";
			this.ckA4.CheckedChanged += new System.EventHandler(this.ckA4_CheckedChanged);
			// 
			// tbVref
			// 
			this.tbVref.Location = new System.Drawing.Point(80, 304);
			this.tbVref.Name = "tbVref";
			this.tbVref.Size = new System.Drawing.Size(40, 20);
			this.tbVref.TabIndex = 20;
			this.tbVref.Text = "5.0";
			this.tbVref.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label6.Location = new System.Drawing.Point(8, 288);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(40, 16);
			this.label6.TabIndex = 21;
			this.label6.Text = "Port:";
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label7.Location = new System.Drawing.Point(80, 288);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(40, 16);
			this.label7.TabIndex = 22;
			this.label7.Text = "Vref:";
			// 
			// label12
			// 
			this.label12.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label12.Location = new System.Drawing.Point(24, 80);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(24, 16);
			this.label12.TabIndex = 27;
			this.label12.Text = "IR";
			// 
			// label13
			// 
			this.label13.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label13.Location = new System.Drawing.Point(24, 248);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(24, 16);
			this.label13.TabIndex = 28;
			this.label13.Text = "IR";
			// 
			// label14
			// 
			this.label14.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label14.Location = new System.Drawing.Point(24, 192);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(24, 16);
			this.label14.TabIndex = 29;
			this.label14.Text = "IR";
			// 
			// label15
			// 
			this.label15.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label15.Location = new System.Drawing.Point(24, 136);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(24, 16);
			this.label15.TabIndex = 30;
			this.label15.Text = "IR";
			// 
			// btStartExcel
			// 
			this.btStartExcel.Location = new System.Drawing.Point(144, 8);
			this.btStartExcel.Name = "btStartExcel";
			this.btStartExcel.Size = new System.Drawing.Size(72, 23);
			this.btStartExcel.TabIndex = 31;
			this.btStartExcel.Text = "Start Excel";
			this.btStartExcel.Click += new System.EventHandler(this.btStartExcel_Click);
			// 
			// pbLines1
			// 
			this.pbLines1.Image = ((System.Drawing.Bitmap)(resources.GetObject("pbLines1.Image")));
			this.pbLines1.Location = new System.Drawing.Point(96, 56);
			this.pbLines1.Name = "pbLines1";
			this.pbLines1.Size = new System.Drawing.Size(24, 80);
			this.pbLines1.TabIndex = 32;
			this.pbLines1.TabStop = false;
			this.pbLines1.Visible = false;
			// 
			// pbLines2
			// 
			this.pbLines2.Image = ((System.Drawing.Bitmap)(resources.GetObject("pbLines2.Image")));
			this.pbLines2.Location = new System.Drawing.Point(96, 168);
			this.pbLines2.Name = "pbLines2";
			this.pbLines2.Size = new System.Drawing.Size(24, 80);
			this.pbLines2.TabIndex = 33;
			this.pbLines2.TabStop = false;
			this.pbLines2.Visible = false;
			// 
			// tPower1
			// 
			this.tPower1.Location = new System.Drawing.Point(128, 80);
			this.tPower1.Name = "tPower1";
			this.tPower1.ReadOnly = true;
			this.tPower1.Size = new System.Drawing.Size(40, 20);
			this.tPower1.TabIndex = 34;
			this.tPower1.Text = "0";
			this.tPower1.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.tPower1.Visible = false;
			// 
			// tEfficiency
			// 
			this.tEfficiency.Location = new System.Drawing.Point(136, 136);
			this.tEfficiency.Name = "tEfficiency";
			this.tEfficiency.ReadOnly = true;
			this.tEfficiency.Size = new System.Drawing.Size(40, 20);
			this.tEfficiency.TabIndex = 35;
			this.tEfficiency.Text = "0";
			this.tEfficiency.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.tEfficiency.Visible = false;
			// 
			// tPower2
			// 
			this.tPower2.Location = new System.Drawing.Point(128, 192);
			this.tPower2.Name = "tPower2";
			this.tPower2.ReadOnly = true;
			this.tPower2.Size = new System.Drawing.Size(40, 20);
			this.tPower2.TabIndex = 36;
			this.tPower2.Text = "0";
			this.tPower2.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.tPower2.Visible = false;
			// 
			// lbP1
			// 
			this.lbP1.Location = new System.Drawing.Point(168, 88);
			this.lbP1.Name = "lbP1";
			this.lbP1.Size = new System.Drawing.Size(40, 16);
			this.lbP1.TabIndex = 37;
			this.lbP1.Text = "Watts";
			this.lbP1.Visible = false;
			// 
			// lbP2
			// 
			this.lbP2.Location = new System.Drawing.Point(168, 200);
			this.lbP2.Name = "lbP2";
			this.lbP2.Size = new System.Drawing.Size(40, 16);
			this.lbP2.TabIndex = 38;
			this.lbP2.Text = "Watts";
			this.lbP2.Visible = false;
			// 
			// lbEff
			// 
			this.lbEff.Location = new System.Drawing.Point(176, 144);
			this.lbEff.Name = "lbEff";
			this.lbEff.Size = new System.Drawing.Size(40, 16);
			this.lbEff.TabIndex = 39;
			this.lbEff.Text = "% Eff.";
			this.lbEff.Visible = false;
			// 
			// CPFLite
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(232, 341);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lbEff,
																		  this.lbP2,
																		  this.lbP1,
																		  this.tPower2,
																		  this.tEfficiency,
																		  this.tPower1,
																		  this.pbLines2,
																		  this.pbLines1,
																		  this.btStartExcel,
																		  this.label7,
																		  this.label6,
																		  this.tbVref,
																		  this.ckA4,
																		  this.ckA3,
																		  this.ckA2,
																		  this.ckA1,
																		  this.tbA4,
																		  this.tbA3,
																		  this.tbA2,
																		  this.tbA1,
																		  this.cbComPort,
																		  this.label1,
																		  this.tbV4,
																		  this.tbV3,
																		  this.tbV2,
																		  this.tbV1,
																		  this.tbTime,
																		  this.button1,
																		  this.label15,
																		  this.label14,
																		  this.label13,
																		  this.label12,
																		  this.label5,
																		  this.label4,
																		  this.label3,
																		  this.label2});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "CPFLite";
			this.Text = "CPFLogger Lite v0.7";
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new CPFLite());
		}


		private void button1_Click(object sender, System.EventArgs e)
		{
			if (bBtnOn == false)
			{
				ReaderThread.dVref = Convert.ToDouble(tbVref.Text);
				if (bExcelRunning == true) {exDump.Counter = 1;}

				//Threadstuff
				m_EventStopThread.Reset();
				m_EventThreadStopped.Reset();
				m_WorkerThread = new Thread(new ThreadStart(this.WorkerThreadFunction));
				m_WorkerThread.Name = "Reader Thread";
				m_WorkerThread.Start();
				bBtnOn = true;
				this.button1.Text = "Stop Log";
			}
			else
			{
				StopThread();
				bBtnOn = false;
				this.button1.Text = "Start Log";
			}
		}


		private void WorkerThreadFunction()
		{
			ReaderThread rThread;

			rThread = new ReaderThread(m_EventStopThread, m_EventThreadStopped, this);

			rThread.Run();
		}


		private void StopThread()
		{
			if ( m_WorkerThread != null  &&  m_WorkerThread.IsAlive )  // thread is active
			{
				ReaderThread.bStopThread = true;
				// set event "Stop"
				m_EventStopThread.Set();

				// wait when thread  will stop or finish
				while (m_WorkerThread.IsAlive)
				{
					// We cannot use here infinite wait because our thread
					// makes syncronous calls to main form, this will cause deadlock.
					// Instead of this we wait for event some appropriate time
					// (and by the way give time to worker thread) and
					// process events. These events may contain Invoke calls.
					if ( WaitHandle.WaitAll(
						(new ManualResetEvent[] {m_EventThreadStopped}), 
						100,
						true) )
					{
						break;
					}

					Application.DoEvents();
				}
			}
		}


		private void AddString(String[] contents)
		{
			//Dump the voltages into the form's text boxes.
			tbTime.Text = contents[0];
			tbV1.Text = contents[1];
			tbV2.Text = contents[2];
			tbV3.Text = contents[3];
			tbV4.Text = contents[4];

			//Dump the power and efficiency into the text boxes.
			tPower1.Text = contents[5];
			tPower2.Text = contents[6];
			tEfficiency.Text = contents[7];

			//If the excel object has been created..
			if (bExcelRunning == true)
			{
				//Dump the results into excel.
				exDump.ParseArray(contents);

				//Increment the row counter.
				exDump.Counter = exDump.Counter + 1;
			}
		}


		private void ThreadFinished()
		{
			bBtnOn = false;
			this.button1.Text = "Start Log";
		}


		//Get the Isense variables when the box is checked..
		private void ckA1_CheckedChanged(object sender, System.EventArgs e)
		{
			ReaderThread.bA1 = this.ckA1.Checked;
			ReaderThread.iA1 = Convert.ToDouble(this.tbA1.Text);
			if (this.ckA1.Checked == true) {this.tbA1.ReadOnly = true;}
			else { this.tbA1.ReadOnly = false;}

			if ((ReaderThread.bA1 & !ReaderThread.bA2) | (!ReaderThread.bA1 & ReaderThread.bA2))
			{bP1Enabled = true; PowerEffEnabler();}
			else
			{bP1Enabled = false; PowerEffEnabler();}
		}

		private void ckA2_CheckedChanged(object sender, System.EventArgs e)
		{
			ReaderThread.bA2 = this.ckA2.Checked;
			ReaderThread.iA2 = Convert.ToDouble(this.tbA2.Text);
			if (this.ckA2.Checked == true) {this.tbA2.ReadOnly = true;}
			else { this.tbA2.ReadOnly = false;}

			if ((ReaderThread.bA1 & !ReaderThread.bA2) | (!ReaderThread.bA1 & ReaderThread.bA2))
			{bP1Enabled = true; PowerEffEnabler();}
			else
			{bP1Enabled = false; PowerEffEnabler();}
		}

		private void ckA3_CheckedChanged(object sender, System.EventArgs e)
		{
			ReaderThread.bA3 = this.ckA3.Checked;
			ReaderThread.iA3 = Convert.ToDouble(this.tbA3.Text);
			if (this.ckA3.Checked == true) {this.tbA3.ReadOnly = true;}
			else { this.tbA3.ReadOnly = false;}

			if ((ReaderThread.bA3 & !ReaderThread.bA4) | (!ReaderThread.bA3 & ReaderThread.bA4))
			{bP2Enabled = true; PowerEffEnabler();}
			else
			{bP2Enabled = false; PowerEffEnabler();}

		}

		private void ckA4_CheckedChanged(object sender, System.EventArgs e)
		{
			ReaderThread.bA4 = this.ckA4.Checked;
			ReaderThread.iA4 = Convert.ToDouble(this.tbA4.Text);
			if (this.ckA4.Checked == true) {this.tbA4.ReadOnly = true;}
			else { this.tbA4.ReadOnly = false;}
			ReaderThread.bA3 = this.ckA3.Checked;
			ReaderThread.iA3 = Convert.ToDouble(this.tbA3.Text);
			if (this.ckA3.Checked == true) {this.tbA3.ReadOnly = true;}
			else { this.tbA3.ReadOnly = false;}

			if ((ReaderThread.bA3 & !ReaderThread.bA4) | (!ReaderThread.bA3 & ReaderThread.bA4))
			{bP2Enabled = true; PowerEffEnabler();}
			else
			{bP2Enabled = false; PowerEffEnabler();}
		}


		//Set the com port variable from the combobox list.
		private void cbComPort_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			ReaderThread.sComPort = this.cbComPort.SelectedItem.ToString();
		}


		//Start excel (create the excel object) when the button is clicked.
		private void btStartExcel_Click(object sender, System.EventArgs e)
		{
			exDump = new ExcelDump();
			bExcelRunning = true;
		}


		private void PowerEffEnabler()
		{
			if (bP1Enabled)
			{
				this.pbLines1.Visible = true;
				this.tPower1.Visible = true;
				this.lbP1.Visible = true;
				if(bExcelRunning){exDump.bDumpP1 = true;}
			}
			else
			{
				this.pbLines1.Visible = false;
				this.tPower1.Visible = false;
				this.lbP1.Visible = false;
				if(bExcelRunning){exDump.bDumpP1 = false;}
			}

			if (bP2Enabled)
			{
				this.pbLines2.Visible = true;
				this.tPower2.Visible = true;
				this.lbP2.Visible = true;
				if(bExcelRunning){exDump.bDumpP2 = true;}
			}
			else
			{
				this.pbLines2.Visible = false;
				this.tPower2.Visible = false;
				this.lbP2.Visible = false;
				if(bExcelRunning){exDump.bDumpP2 = false;}
			}

			if (bP1Enabled & bP2Enabled)
			{
				this.tEfficiency.Visible = true;
				this.lbEff.Visible = true;
			}
			else
			{
				this.tEfficiency.Visible = false;
				this.lbEff.Visible = false;			}
		}
	}
}
