using System;
using System.Windows.Forms;
using Excel;

namespace CPFLite
{

	public class ExcelDump
	{
		//Counter to increment Excel row.
		public int Counter = 1;

		public bool bDumpP1 = false;
		public bool bDumpP2 = false;

		//Starts Excel and gives a handle to the object.
		private Excel.Application ExcelObj = new Excel.Application();

		public ExcelDump()
		{
			//If excel didn't open, toss up an error box.
			if (ExcelObj  == null) 
			{
				MessageBox.Show("ERROR: EXCEL couldn't be started!");
				System.Windows.Forms.Application.Exit();
			}

			//Make excel visible (default is hidden).
			ExcelObj.Visible = true;

			//Create a new workbook.
			ExcelObj.Workbooks.Add(XlWBATemplate.xlWBATWorksheet);

		}


		public void ParseArray(string[] Values)
		{
			int iParseCount = 5;

			string[] sDump = new string[8];

			Values.CopyTo(sDump, 0);

			//If both Power1 and Power2 are not enabled, dump inputs only.
			if (!bDumpP1 & !bDumpP2){iParseCount=5;}

			//If Power1 is enabled, dump inputs and Power1.
			if (bDumpP1 & !bDumpP2) {iParseCount=6;}

			//If Power2 is enabled, dump inputs and Power2. Blank out Power1.
			if (!bDumpP1 & bDumpP2) {iParseCount=7; sDump[5] = "";}

			//If both PowerX's enabled, dump all data.
			if (bDumpP1 & bDumpP2) {iParseCount=8;}

			//Parse out the values from the 5 wide string array.
			for (int i = 0; i < iParseCount; i++)
			{
				//Dump the values to the excel writing routine.
				WriteExcel(i, sDump[i]);
			}

		}


		//Writes the values to excel. Stolen directly from c-sharpcorner.com
		private void WriteExcel(int index, string sVal0)
		{
			Workbooks workbooks = ExcelObj.Workbooks;

			// get the workbook from the existing spreadsheet
			_Workbook workbook = workbooks.get_Item(1);

			// get the collection of sheets in the workbook
			Sheets sheets = workbook.Worksheets;

			// get the first and only worksheet from the collection 
			// of worksheets
			_Worksheet worksheet = (_Worksheet) sheets.get_Item(1);

			// form a range with a single cell based on the index of the quote
			// and the Incremented Counter.
			char rangeChar = (char)(index + 65);
			string strCell = rangeChar + Convert.ToString(Counter);
			Range range2 = worksheet.get_Range(strCell, strCell);

			// Populate the cells
			range2.set_Value(Type.Missing, sVal0);

		}

	}
}
